/* arbol_binario_busqueda.h */

#include <stdio.h>
#include <stdlib.h>

typedef int tipo_clave;

typedef struct nodo {
  tipo_clave clave;
  struct nodo *izq;
  struct nodo *der;      
} nodo_arbol;

/* puntero a nodo si correcto. NULL en otro caso */
nodo_arbol *crear_nodo(tipo_clave);

/* puntero a nodo si encontrado. NULL en otro caso */
nodo_arbol *buscar_clave(nodo_arbol *, tipo_clave);

void insertar_clave_recur(nodo_arbol **, tipo_clave);

/* 1 si insertada. 0 en otro caso */
int insertar_clave(nodo_arbol **, tipo_clave);

void borrar_clave_recur(nodo_arbol **, tipo_clave);

/* 1 si borrada. 0 en otro caso */ 
int borrar_clave(nodo_arbol **, tipo_clave);

void imprime_inorden(nodo_arbol *, int);
